library income;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  income1 in 'income1.pas';



type
TIncomeMax = class(TIncome)

private
 FRate : Real;
public
constructor Create;
function GetIncome(const aNetto: Currency): Currency; override;
function Power(X: Real; Y: Integer): Real;
procedure SetRate(const aPercent: Integer; aYear: integer); override;
end;

{-------------------------------------------------------------}
{ Implementierung von Income als ObjServer}
{-------------------------------------------------------------}
constructor TIncomeMax.Create;
begin
inherited Create;
FRate := 1.234;
Assert(INCOME_VERSION = 1, 'Falsche Unit-Version!');
end;

function TIncomeMax.GetIncome(const aNetto: Currency): Currency;
begin
Result := aNetto * FRate
end;
procedure TIncomeMax.SetRate(const aPercent : Integer;
                                         aYear: integer);
begin
  FRate := power(1.0 + (aPercent/100),aYear);
end;

function TIncomeMax.Power(X: Real; Y: Integer): Real;
var
  I: Integer;           //comsim
begin
  Result := 1.0;
  I := Y;
  while I > 0 do begin
    if Odd(I) then Result := Result * X;
    I := I div 2; X := Sqr(X);
  end;
end;


{-------------------------------------------------------------}
{ Schnittstellenprozedur }
{-------------------------------------------------------------}
function CreateIncome: TIncomeMax; stdcall;
begin Result := TIncomeMax.Create; end;

{-------------------------------------------------------------}
{ Export der Schnittstellenprozedur }
{-------------------------------------------------------------}
exports CreateIncome resident;
begin
{ nur ein fake}
end.


